#!/usr/bin/env python

# anguis - A distributed assert system over etcd

# The MIT License (MIT)
# 
# Copyright (c) 2018-21 Roberto Reale
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

import json

class AnguisBase(object):

    def get(self, key):
        pass

    def set(self, key, value):
        pass

    def erase(self, key):
        pass

    def exists(self):
        """ Determine if a key exists """
        pass

    def keys(self):
        """ Return all the keys of the keystore """
        pass

    def randomkey(self):
        """ Return a random key from the keystore """
        pass

    def rename(self, key, newkey):
        """ Rename a key """
        pass

    def touch(self, key):
        """ Alters the last access time of a key """
        pass

    def serialize(self, data):
        return json.dumps(data)

    def unserialize(self, ser_data):
        return json.loads(ser_data)

    def __init__(self):
        pass

    def __del__(self):
        pass

# vim: tabstop=8 expandtab shiftwidth=4 softtabstop=4
